Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Oracle Application Development Framework Model Java API Reference 10g Release 3 (10.1.3) B25778-01
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## oracle.jbo.uicli.binding
Class JUFormBinding

`java.lang.Object
java.util.AbstractMap
oracle.jbo.common.JboAbstractMap
oracle.adf.model.binding.DCExecutableBinding
oracle.adf.model.binding.DCBindingContainer
oracle.jbo.uicli.binding.JUFormBinding`

All Implemented Interfaces:
  BindingContainer, DCIExecutable, oracle.jbo.JboExceptionHandler, java.util.Map, oracle.adf.model.RegionBinding, oracle.jbo.VariableManagerOwner

Direct Known Subclasses:
  JUPanelBinding

public class JUFormBinding
extends DCBindingContainer

Corresponds to a Swing JFrame instance and manages bindings used in a frame. The JUFormBinding class provides:

- Management of iterator binding instances.
- Management of control bindings for declarative forms (**for internal framework use only**).
- Manages the findMode status and switches the iterator bindings into approrpriate mode.
- Helper methods for displaying messages in status bar.
- Helper methods for retrieving UIHints from BC4J ViewObject and attribute definitions.

In the JClient Framework, JUPanelBinding extends this class and provides a home to various iterator bindings and control bindings.

See Also:
  `JUPanelBinding`

Nested Class Summary

Nested classes inherited from class java.util.Map
`java.util.Map.Entry`

Field Summary

Fields inherited from class oracle.adf.model.binding.DCBindingContainer
`mControlList, mDataControl, mDataProvider, mIterBindingList, mParamsList`

Fields inherited from class oracle.adf.model.binding.DCExecutableBinding
`mInternalGet_KeyResolved`

Fields inherited from interface oracle.adf.model.RegionBinding
`EXECUTE_MODEL, PREPARE_MODEL, REFRESH_UNKNOWN, RENDER_MODEL, TYPE_EXECUTABLE_REGION`

Fields inherited from interface oracle.adf.model.binding.DCIExecutable
`EXECUTABLE_ACTION, EXECUTABLE_ITERATORBINDING, EXECUTABLE_REGION`

Constructor Summary
`JUFormBinding()` Default constrcutor.
`JUFormBinding(java.lang.Object panel)` Constructor used by JUPanelBinding, which passes in a reference to the JPanel object.

Method Summary
`void` | `addIterBinding(JUIteratorBinding iterBinding)` Adds the given iterator binding name with a framework generated name.
`void` | `addIterBinding(java.lang.String name, JUIteratorBinding iterBinding)` Adds this iterator binding with this form with the given name.
`void` | `addStatusBarInterface(JUStatusBarInterface statusBar)` Helper method to add the given object to the JUApplication's StatusBars.
`void` | `clearIterBindings()` Clean all iterator bindings registered with this form.
`protected DCIteratorBinding` | `createIteratorBinding(java.lang.String voInstanceName, java.lang.String voIterName, java.lang.String voIterBindingName, int rangeSize)` Forces the current control to stop its editing mode (if used, like in JTable).
`boolean` | `displayInShortForm(java.lang.String voName, java.lang.String attrName, LocaleContext locale)` Returns true if the attribute is to displayed in the short(summary) form.
`void` | `displayStatus(JUIteratorBinding iterBinding, java.lang.String msgId, java.lang.Object[] params)` Helper method to display the given message and params via the JUApplication's displayStatus method.
`void` | `displayStatus(java.lang.String msg)` Helper method to display the given message string via the JUApplication's displayStatus method.
`oracle.jbo.VariableValueManager` | `ensureVariableManager()`
`JUControlBinding` | `findControlBinding(java.lang.String name)`
`JUCtrlValueBinding` | `findCtrlValueBinding(java.lang.String name)` *** For internal framework use only ***
`JUIteratorBinding` | `findIterBinding(java.lang.String name)` Returns the iterator binding object of the given name.
`protected void` | `focusGained(DCIteratorBinding iterBinding, DCControlBinding binding, int attrIndex)` Invoked by the framework to notify various status bars of which control has gained the focus.
`JUApplication` | `getApplication()` Returns the JUApplciation object to which this form binding belongs.
`JUControlBinding` | `getControlBinding(java.lang.Object control)`
`int` | `getControlType(java.lang.String voName, java.lang.String attrName, LocaleContext locale)` Returns the preferred control type for this attribute.
`int` | `getDisplayHeight(java.lang.String voName, java.lang.String attrName, LocaleContext locale)` Returns the display width for this attribute.
`java.lang.String` | `getDisplayHint(java.lang.String voName, java.lang.String attrName, LocaleContext locale)` Retrieves the display hint that dictates whether this attribute should be visible or not.
`int` | `getDisplayWidth(java.lang.String voName, java.lang.String attrName, LocaleContext locale)` Returns the display width for this attribute.
`java.lang.String` | `getHint(java.lang.String voName, java.lang.String attrName, LocaleContext locale, java.lang.String sHintName)` Returns the hint value based on the hint name.
`java.lang.String` | `getHint(java.lang.String voName, java.lang.String voAttrName, java.lang.String objectAttrName, LocaleContext locale, java.lang.String sHintName)` Returns the hint value based on the hint name.
`java.lang.String` | `getLabel(java.lang.String voName, java.lang.String attrName, LocaleContext locale)` Retrieves the label to be used in any attribute prompts
`java.lang.String` | `getLabel(java.lang.String voName, java.lang.String voAttrName, java.lang.String objectAttrName, LocaleContext locale)` Retrieves the label to be used in any attribute prompts
`oracle.jbo.ViewObject[]` | `getOrderedVOUsageList()` Returns an ordered list of ViewObject usages in this panel so that a JboException parameters can be transformed from Entity-layer names and exception parameters to ViewObject names and parameters.
`java.lang.Object` | `getPanel()` Returns the associated JPanel object.
`JUIteratorBinding` | `getRangeIterBinding(java.lang.String voInstanceName, java.lang.String voIterName, java.lang.String voIterBindingName, int rangeSize)` Return an Iterator Binding of the given "voIterBindingName", if one already exists by that name, after setting up the iterator binding's range Size to the greater of existing range size and the given range size.
`JUIteratorBinding` | `getRowIterBinding(java.lang.String voInstanceName, java.lang.String voIterName, java.lang.String voIterBindingName)` Return an Iterator Binding of the given "voIterBindingName" if one already exists by that name.
`java.lang.String` | `getTooltip(java.lang.String voName, java.lang.String attrName, LocaleContext locale)` Retrives the tooltip text to be used for this attribute.
`java.lang.String` | `getTooltip(java.lang.String voName, java.lang.String voAttrName, java.lang.String objectAttrName, LocaleContext locale)` Retrives the tooltip text to be used for this attribute.
`boolean` | `hasFormatInformation(java.lang.String voName, java.lang.String attrName, LocaleContext locale)` Returns true if any format hints have been defined for this attribute.
`protected void` | `initializeApplicationModule()` *** For internal framework use only *** Used to setup reference to JUApplication and oracle.jbo.Application objects.
`void` | `initializePanel(java.util.ArrayList controls)` *** For internal framework use only ***
`protected void` | `initializeViewComponent(java.util.ArrayList controls)` *** For internal framework use only ***
`protected DCDataControl` | `internalGetDataControl()` *** For internal framework use only ***
`protected void` | `navigated(DCIteratorBinding iter, NavigationEvent event)` Invoked when a JUIteratorBinding receives a navigated Event from BC4J RowSetIterator
`protected void` | `notifyIteratorChanged(DCIteratorBinding iterBnd, boolean refresh)` Notify each listener of the iteratorChanged event when an iterator changes its data due to execute, re-execute, or change in display mode (find mode or data mode).
`protected void` | `rangeRefreshed(DCIteratorBinding iter, RangeRefreshEvent event)` Invoked when a JUIteratorBinding receives a rangeRefreshed Event from BC4J RowSetIterator
`protected void` | `rangeScrolled(DCIteratorBinding iter, ScrollEvent event)` Invoked when a JUIteratorBinding receives a rangeScrolled Event from BC4J RowSetIterator
`boolean` | `removeIterBinding(java.lang.String name)` If an iterator binding exists with the given name, remove it from the internal members.
`void` | `removeStatusBarInterface(JUStatusBarInterface statusBar)` Helper method to remove the given object to the JUApplication's StatusBars.
`protected void` | `rowDeleted(DCIteratorBinding iter, DeleteEvent event)` Invoked when a JUIteratorBinding receives a rowDeleted Event from BC4J RowSetIterator
`protected void` | `rowInserted(DCIteratorBinding iter, InsertEvent event)` Invoked when a JUIteratorBinding receives a rowInserted Event from BC4J RowSetIterator
`protected void` | `rowUpdated(DCIteratorBinding iter, UpdateEvent event)` Invoked when a JUIteratorBinding receives a rowUpdated Event from BC4J RowSetIterator
`void` | `setApplication(JUApplication app)` Sets the JUApplication instance in this form binding and adds it to the JUApplication.
`void` | `setPanel(java.lang.Object panel)` Associates this form binding object with a JPanel object.
`protected void` | `setPanelInternal(java.lang.Object panel)` Sets internal member variable with the given panel instance.

Methods inherited from class oracle.adf.model.binding.DCBindingContainer
`addControlBinding, addControlBinding, addExecutableBinding, addExecutableBinding, addIteratorBinding, addIteratorBinding, addRegionListener, addStatusBarInterface, addValidationListener, aliasExists, beforeCurrencyChange, beforeSaveTransaction, beforeSetAttribute, cacheException, callBeforeRowNavigated, callBeforeSaveTransaction, callBeforeSetAttribute, clearExecutableBindings, clearIteratorBindings, displayStatus, evaluateParameter, execute, executeIfNeeded, findCtrlBinding, findDataControl, findExecutableBinding, findIteratorBinding, findNamedObject, findParameter, findRegionBinding, finishedProcessingPiggyback, getActionProcessor, getAllIterBindingList, getApplicationModule, getAttributeBindings, getBindingContext, getControlBinding, getControlBindings, getCtrlBinding, getCtrlBinding, getCtrlBindingList, getDataControl, getDef, getEditingMode, getExceptionsList, getExecutableBindings, getExecutableDef, getExecutableType, getFullName, getIteratorBinding, getIteratorBinding, getIterBindingList, getIterBindings, getLocaleContext, getMessageBundleClass, getOperationBinding, getOperationBindings, getOrderedVOUsageList, getParameterAlias, getParametersList, getParametersMap, getRegionBindings, getRegionContainer, getRegionController, getRegionListeners, getStateToken, getStateTokenId, getTransientRefreshFlag, getValidationListeners, getVariableManager, getVariableManagerOwner, getViewComponent, handleException, handleWarning, hashCode, hasRefreshParametersChanged, hasVariables, initializeFromDef, internalGet, internalRefreshControl, isEditingStopped, isErrorHandlerActive, isExecuteOnRollback, isFindMode, isTokenValidationEnabled, isViewable, processException, processInputValues, refresh, refresh, refreshControl, release, release, removeControlBinding, removeControlBinding, removeExecutableBinding, removeIteratorBinding, removeParameter, removeParameter, removeRegionListener, removeStatusBarInterface, removeValidationListener, reportException, resetInputState, setApplicationModule, setBindingContext, setDataControl, setDef, setEnableTokenValidation, setErrorHandlerActive, setExecuteOnRollback, setFindMode, setFindMode, setParameterExpression, setParameterValues, setViewComponentInternal, toString, usesDef, validate, validateInputValues, validateToken`

Methods inherited from class oracle.adf.model.binding.DCExecutableBinding
`addDependentExecutable, get, getBindingContainer, getDependents, getName, getRefreshExpression, getRefreshOption, isRefreshed, refreshIfNeeded, removeDependentExecutable, resetDependentsRefresh, setBindingContainer, setExecutableDef, setName, setRefreshed, setRefreshExpression, setRefreshOption`

Methods inherited from class oracle.jbo.common.JboAbstractMap
`entrySet, equals, internalPut, put`

Methods inherited from class java.util.AbstractMap
`clear, clone, containsKey, containsValue, isEmpty, keySet, putAll, remove, size, values`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface oracle.binding.BindingContainer
`getName`

Methods inherited from interface java.util.Map
`clear, containsKey, containsValue, entrySet, equals, get, isEmpty, keySet, put, putAll, remove, size, values`

Methods inherited from interface oracle.jbo.VariableManagerOwner
`getName`

Constructor Detail

### JUFormBinding

    public JUFormBinding()

  Default constrcutor.

### JUFormBinding

    public JUFormBinding(java.lang.Object panel)

  Constructor used by JUPanelBinding, which passes in a reference to the JPanel object.

Method Detail

### getApplication

    public JUApplication getApplication()

  Returns the JUApplciation object to which this form binding belongs.

### setApplication

    public void setApplication(JUApplication app)

  Sets the JUApplication instance in this form binding and adds it to the JUApplication. If this form binding is already registered with a JUApplication, then it throws an InvalidOperException.
  Throws:
    `InvalidOperException`

### getPanel

    public final java.lang.Object getPanel()

  Returns the associated JPanel object.

### setPanelInternal

    protected void setPanelInternal(java.lang.Object panel)

  Sets internal member variable with the given panel instance.

### findIterBinding

    public final JUIteratorBinding findIterBinding(java.lang.String name)

  Returns the iterator binding object of the given name.

### addIterBinding

    public final void addIterBinding(JUIteratorBinding iterBinding)

  Adds the given iterator binding name with a framework generated name.

### addIterBinding

    public final void addIterBinding(java.lang.String name,
                                     JUIteratorBinding iterBinding)

  Adds this iterator binding with this form with the given name.
  Throws:
    `InvalidObjNameException` - if an invalid name is passed in.
    `NameClashException` - if given a duplicate name.

### removeIterBinding

    public final boolean removeIterBinding(java.lang.String name)

  If an iterator binding exists with the given name, remove it from the internal members.

### clearIterBindings

    public final void clearIterBindings()

  Clean all iterator bindings registered with this form.

### findControlBinding

    public final JUControlBinding findControlBinding(java.lang.String name)

### findCtrlValueBinding

    public JUCtrlValueBinding findCtrlValueBinding(java.lang.String name)

  *** For internal framework use only ***

### getControlBinding

    public final JUControlBinding getControlBinding(java.lang.Object control)

### getRowIterBinding

    public JUIteratorBinding getRowIterBinding(java.lang.String voInstanceName,
                                               java.lang.String voIterName,
                                               java.lang.String voIterBindingName)

  Return an Iterator Binding of the given "voIterBindingName" if one already exists by that name. If not, create an IteratorBinding object that references a default iterator of the ViewObject instance named voInstanceName (and optionally the iterator named voIterName). Return this created iterator binding after adding it to internal lists.

  Various control bindings that display just one row's attribute invoke this method to find or create the iterator binding for which they display an attribute data.

### getRangeIterBinding

    public JUIteratorBinding getRangeIterBinding(java.lang.String voInstanceName,
                                                 java.lang.String voIterName,
                                                 java.lang.String voIterBindingName,
                                                 int rangeSize)

  Return an Iterator Binding of the given "voIterBindingName", if one already exists by that name, after setting up the iterator binding's range Size to the greater of existing range size and the given range size. If range size is -1, that indicates all rows in the range and hence takes precedence in the above comparison.

  If not, create an IteratorBinding object that references a default iterator of the ViewObject instance named voInstanceName (and optionally the iterator named voIterName). Return this created iterator binding after adding it to internal lists.

  Various control bindings that are capable of displaying more than one row of data invoke this method to create their iterator binding with a preferred range size.

### addStatusBarInterface

    public void addStatusBarInterface(JUStatusBarInterface statusBar)

  Helper method to add the given object to the JUApplication's StatusBars.

### removeStatusBarInterface

    public void removeStatusBarInterface(JUStatusBarInterface statusBar)

  Helper method to remove the given object to the JUApplication's StatusBars.

### displayStatus

    public void displayStatus(JUIteratorBinding iterBinding,
                              java.lang.String msgId,
                              java.lang.Object[] params)

  Helper method to display the given message and params via the JUApplication's displayStatus method. This method becomes a no-op if this form is not registered with a JUApplication

### displayStatus

    public void displayStatus(java.lang.String msg)

  Helper method to display the given message string via the JUApplication's displayStatus method. This method becomes a no-op if this form is not registered with a JUApplication
  Overrides:
    `displayStatus` in class `DCBindingContainer`

### getLabel

    public java.lang.String getLabel(java.lang.String voName,
                                     java.lang.String attrName,
                                     LocaleContext locale)

  Retrieves the label to be used in any attribute prompts

### getTooltip

    public java.lang.String getTooltip(java.lang.String voName,
                                       java.lang.String attrName,
                                       LocaleContext locale)

  Retrives the tooltip text to be used for this attribute.

### getDisplayHint

    public java.lang.String getDisplayHint(java.lang.String voName,
                                           java.lang.String attrName,
                                           LocaleContext locale)

  Retrieves the display hint that dictates whether this attribute should be visible or not. The two possible values are:
  - ATTRIBUTE_DISPLAY_HINT_DISPLAY = "Display";
  - ATTRIBUTE_DISPLAY_HINT_HIDE = "Hide";

### getControlType

    public int getControlType(java.lang.String voName,
                              java.lang.String attrName,
                              LocaleContext locale)

  Returns the preferred control type for this attribute.

### getDisplayWidth

    public int getDisplayWidth(java.lang.String voName,
                               java.lang.String attrName,
                               LocaleContext locale)

  Returns the display width for this attribute.

### getDisplayHeight

    public int getDisplayHeight(java.lang.String voName,
                                java.lang.String attrName,
                                LocaleContext locale)

  Returns the display width for this attribute.

### getHint

    public java.lang.String getHint(java.lang.String voName,
                                    java.lang.String attrName,
                                    LocaleContext locale,
                                    java.lang.String sHintName)

  Returns the hint value based on the hint name.

### hasFormatInformation

    public boolean hasFormatInformation(java.lang.String voName,
                                        java.lang.String attrName,
                                        LocaleContext locale)

  Returns true if any format hints have been defined for this attribute. This function should be used to bracket any calls to the formatting API.

### displayInShortForm

    public boolean displayInShortForm(java.lang.String voName,
                                      java.lang.String attrName,
                                      LocaleContext locale)

  Returns true if the attribute is to displayed in the short(summary) form.

### getLabel

    public java.lang.String getLabel(java.lang.String voName,
                                     java.lang.String voAttrName,
                                     java.lang.String objectAttrName,
                                     LocaleContext locale)

  Retrieves the label to be used in any attribute prompts

### getTooltip

    public java.lang.String getTooltip(java.lang.String voName,
                                       java.lang.String voAttrName,
                                       java.lang.String objectAttrName,
                                       LocaleContext locale)

  Retrives the tooltip text to be used for this attribute.

### getHint

    public java.lang.String getHint(java.lang.String voName,
                                    java.lang.String voAttrName,
                                    java.lang.String objectAttrName,
                                    LocaleContext locale,
                                    java.lang.String sHintName)

  Returns the hint value based on the hint name.

### getOrderedVOUsageList

    public oracle.jbo.ViewObject[] getOrderedVOUsageList()

  Returns an ordered list of ViewObject usages in this panel so that a JboException parameters can be transformed from Entity-layer names and exception parameters to ViewObject names and parameters.

### initializeViewComponent

    protected void initializeViewComponent(java.util.ArrayList controls)

  Description copied from class: `DCBindingContainer`
  *** For internal framework use only ***
  Overrides:
    `initializeViewComponent` in class `DCBindingContainer`

### initializePanel

    public void initializePanel(java.util.ArrayList controls)

  *** For internal framework use only ***

### initializeApplicationModule

    protected void initializeApplicationModule()

  *** For internal framework use only *** Used to setup reference to JUApplication and oracle.jbo.Application objects.
  Overrides:
    `initializeApplicationModule` in class `DCBindingContainer`

### setPanel

    public void setPanel(java.lang.Object panel)

  Associates this form binding object with a JPanel object.

### focusGained

    protected void focusGained(DCIteratorBinding iterBinding,
                               DCControlBinding binding,
                               int attrIndex)

  Invoked by the framework to notify various status bars of which control has gained the focus.
  Overrides:
    `focusGained` in class `DCBindingContainer`

### notifyIteratorChanged

    protected void notifyIteratorChanged(DCIteratorBinding iterBnd,
                                         boolean refresh)

  Notify each listener of the iteratorChanged event when an iterator changes its data due to execute, re-execute, or change in display mode (find mode or data mode).
  Overrides:
    `notifyIteratorChanged` in class `DCBindingContainer`

### rangeRefreshed

    protected void rangeRefreshed(DCIteratorBinding iter,
                                  RangeRefreshEvent event)

  Invoked when a JUIteratorBinding receives a rangeRefreshed Event from BC4J RowSetIterator
  Overrides:
    `rangeRefreshed` in class `DCBindingContainer`
  Parameters:
    `iter` - that received the rangeRefreshed event.
    `event` - a description of the new ranges.

### rangeScrolled

    protected void rangeScrolled(DCIteratorBinding iter,
                                 ScrollEvent event)

  Invoked when a JUIteratorBinding receives a rangeScrolled Event from BC4J RowSetIterator
  Overrides:
    `rangeScrolled` in class `DCBindingContainer`
  Parameters:
    `iter` - that received the rangeScrolled event.
    `event` - a description of the new range.

### rowInserted

    protected void rowInserted(DCIteratorBinding iter,
                               InsertEvent event)

  Invoked when a JUIteratorBinding receives a rowInserted Event from BC4J RowSetIterator
  Overrides:
    `rowInserted` in class `DCBindingContainer`
  Parameters:
    `iter` - that received the rowInserted event.
    `event` - a description of the new Row object.

### rowDeleted

    protected void rowDeleted(DCIteratorBinding iter,
                              DeleteEvent event)

  Invoked when a JUIteratorBinding receives a rowDeleted Event from BC4J RowSetIterator
  Overrides:
    `rowDeleted` in class `DCBindingContainer`
  Parameters:
    `iter` - that received the rowDeleted event.
    `event` - a description of the deleted Row object.

### rowUpdated

    protected void rowUpdated(DCIteratorBinding iter,
                              UpdateEvent event)

  Invoked when a JUIteratorBinding receives a rowUpdated Event from BC4J RowSetIterator
  Overrides:
    `rowUpdated` in class `DCBindingContainer`
  Parameters:
    `iter` - that received the rowUpdated event.
    `event` - a description of the modified Row object.

### navigated

    protected void navigated(DCIteratorBinding iter,
                             NavigationEvent event)

  Invoked when a JUIteratorBinding receives a navigated Event from BC4J RowSetIterator
  Overrides:
    `navigated` in class `DCBindingContainer`
  Parameters:
    `iter` - that received the navigated event.
    `event` - a description of the new and previous current rows.

### createIteratorBinding

    protected DCIteratorBinding createIteratorBinding(java.lang.String voInstanceName,
                                                      java.lang.String voIterName,
                                                      java.lang.String voIterBindingName,
                                                      int rangeSize)

  Forces the current control to stop its editing mode (if used, like in JTable). Calls beforeSaveTransaction() method to notify all validation listeners.
  Overrides:
    `createIteratorBinding` in class `DCBindingContainer`

### ensureVariableManager

    public oracle.jbo.VariableValueManager ensureVariableManager()

  Specified by:
    `ensureVariableManager` in interface `oracle.jbo.VariableManagerOwner`
  Overrides:
    `ensureVariableManager` in class `DCBindingContainer`

### internalGetDataControl

    protected DCDataControl internalGetDataControl()

  *** For internal framework use only ***
  Overrides:
    `internalGetDataControl` in class `DCBindingContainer`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Oracle Application Development Framework Model Java API Reference 10g Release 3 (10.1.3) B25778-01
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 1997, 2005, Oracle. All rights reserved.